// /  ( )
// Proteus; icq:133575351; lawnmower-man@mail.ru

#include<stdio.h>
#include<windows.h>

#define P 256  //  

class Haff{
struct item_st{int p;int count;int p1;int p2;};
protected:
	int tree_root;			//!<  
	item_st tree[P*2-1];	//!< 
	void InitTree();								//!<  
	void UpdateTree(int index);						//!<  
};

class HF_Encoder:Haff{
	BYTE byte,byte_shift; 
	void WriteBit(FILE *file,bool bit);		//!<    
	void WriteCode(FILE *file,int index);	//!<    
	int SizeOfFile(FILE *file);				//!<   
public:
	void Encode(FILE*,FILE*);
	static void _Encode(FILE*,FILE*);
};


class HF_Decoder:Haff{
	BYTE byte,byte_shift; 
	bool ReadBit(FILE*);		//!<    
	BYTE ReadCode(FILE*);		//!<    
public:
	void Decode(FILE*,FILE*);
	static void _Decode(FILE*,FILE*);
};



void Haff::InitTree()
{
	int i1,i2,c,n,l;
	c=P; i1=0; i2=P; l=-1;
	for(n=0; n<P*2-1; n++) tree[n].count=0,tree[n].p1=tree[n].p2=-1;
	while(c>1) {
		for(n=0; n<c/2; n++) {
			tree[i2].p1=i1; tree[i1++].p=i2;
			tree[i2].p2=i1; tree[i1++].p=i2;
			i2++;
		}
		if(c&1) {
			if(l<0) l=i1++,c++;
			else {
				tree[i2].p2=l ; tree[l   ].p=i2;
				tree[i2].p1=i1; tree[i1++].p=i2;
				l=-1; i2++;
			}
		}
		c=c/2;
	}
	tree_root=i2-1;tree[tree_root].p=-1;
}


//    [index]
//       |
// [a]---+---[n]
//            |
//       [b]--+---[c]    
void Haff::UpdateTree(int index)
{
	int a,b,c;		//   
	int c1,c2,c0;	//  
	int n;			//  
	for(;;) {
		tree[index].count++;
		index=tree[index].p;
		if(index<0) return;
		n=tree[index].p2;
		c1=tree[tree[index].p1].count;
		c2=tree[n].count;
		if(c1>c2) {
			n=tree[index].p1;
			tree[index].p1=tree[index].p2;
			tree[index].p2=n;
		}
		a=tree[index].p1;
		b=tree[n].p1;
		c=tree[n].p2;
		if(b<0 || c<0) continue;
		c0=tree[a].count+tree[b].count;
		if(c0<tree[b].count+tree[c].count) {
			tree[a].p=n;
			tree[c].p=index;
			if(tree[a].count<=tree[b].count) tree[n].p1=a,tree[n].p2=b;
			else tree[n].p1=b,tree[n].p2=a;
			tree[n].count=c0;
			if(c0<=tree[c].count) tree[index].p1=n,tree[index].p2=c;
			else tree[index].p1=c,tree[index].p2=n;
		}
	}
}


void HF_Encoder::WriteBit(FILE *file,bool b)
{
	if(b) byte|=byte_shift;
	byte_shift<<=1;
	if(byte_shift) return;
	fputc(byte,file);
	byte_shift=1; byte=0;
}

void HF_Encoder::WriteCode(FILE *file,int index)
{
	if(tree[index].p<0) return;
	WriteCode(file,tree[index].p);
	WriteBit(file,tree[tree[index].p].p1!=index);
}


int HF_Encoder::SizeOfFile(FILE *file)
{
	int size;
	fseek(file,0,SEEK_END);
	size=ftell(file);
	fseek(file,0,SEEK_SET);
	return size;
}


void HF_Encoder::_Encode(FILE *input,FILE *output)
{
	HF_Encoder obj;
	obj.Encode(input,output);
}


void HF_Encoder::Encode(FILE *input,FILE *output)
{
	BYTE sym; int index;
	byte=0; byte_shift=1;
	InitTree();
	index=SizeOfFile(input);
	fwrite(&index,1,sizeof(index),output);
	int n=0;
	while(!feof(input)) {
//		n++; printf(">> %d\n",n);
		sym=fgetc(input);
		WriteCode(output,sym);
		UpdateTree(sym);
	}
	if(byte_shift!=1) fputc(byte,output);	//   
}


bool HF_Decoder::ReadBit(FILE *file)
{
	bool res;
	if(!byte_shift) {
		if(feof(file)) return 0;
		byte=fgetc(file);
		byte_shift=1;		
	}
	res=(byte&byte_shift)!=0;
	byte_shift<<=1;
	return res;
}


BYTE HF_Decoder::ReadCode(FILE *file)
{
	bool sym;
	int index=tree_root;
	for(;;) {
		if(index<P) break;
		sym=ReadBit(file);
		index=sym?tree[index].p2:tree[index].p1;
		if(index<0) return -1;
	}
	return index;
}

void HF_Decoder::_Decode(FILE *input,FILE *output)
{
	HF_Decoder obj;
	obj.Decode(input,output);
}



void HF_Decoder::Decode(FILE *input,FILE *output)
{
	int n,size; BYTE sym;
	byte=0; byte_shift=0;
	InitTree();
	fread(&size,1,sizeof(size),input);
	for(n=0;n<size;n++)
	{
		sym=ReadCode(input);
		fputc(sym,output);
		UpdateTree(sym);
	}
}


int main(int count,char **list)
{
	FILE *input,*output;
	if(count!=4) {
		printf("%s -e infile outfile\n",list[0]);
		printf("%s -d infile outfile\n",list[0]);
		return 1;
	}
	if(list[1][0]!='-' || list[1][1]!='e' && list[1][1]!='d') {
		printf("Syntax error\n\a");
		return 2;
	}
	input =fopen(list[2],"rb");
	output=fopen(list[3],"wb");
	if(!input || !output) {
		printf("IO error\n\a");
		return 3;
	}
	switch(list[1][1]) {
	case 'e': HF_Encoder::_Encode(input,output); break;	// 
	case 'd': HF_Decoder::_Decode(input,output); break;	// 
	}
	fclose(input);
	fclose(output);
	return 0;
}


